Index: squid/include/Array.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Array.h,v
retrieving revision 1.6
retrieving revision 1.6.44.1
diff -u -r1.6 -r1.6.44.1
--- squid/include/Array.h	9 Oct 2001 21:17:59 -0000	1.6
+++ squid/include/Array.h	3 Oct 2002 01:04:32 -0000	1.6.44.1
@@ -1,5 +1,5 @@
 /*
- * $Id: Array.h,v 1.6 2001/10/09 21:17:59 squidadm Exp $
+ * $Id: Array.h,v 1.6.44.1 2002/10/03 01:04:32 rbcollins Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -47,7 +47,7 @@
 extern void arrayInit(Array * s);
 extern void arrayClean(Array * s);
 extern void arrayDestroy(Array * s);
-extern void arrayAppend(Array * s, void *obj);
+SQUIDCEXTERN void arrayAppend(Array * s, void *obj);
 extern void arrayPreAppend(Array * s, int app_count);
 
 
Index: squid/include/MemPool.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Attic/MemPool.h,v
retrieving revision 1.2
retrieving revision 1.2.32.1
diff -u -r1.2 -r1.2.32.1
--- squid/include/MemPool.h	6 Apr 2002 11:34:49 -0000	1.2
+++ squid/include/MemPool.h	3 Oct 2002 01:04:32 -0000	1.2.32.1
@@ -141,29 +141,29 @@
 /* memPools */
 
 /* Allocator API */
-extern MemPool *memPoolCreate(const char *label, size_t obj_size);
-extern void *memPoolAlloc(MemPool * pool);
-extern void memPoolFree(MemPool * pool, void *obj);
-extern void memPoolDestroy(MemPool ** pool);
-
-extern MemPoolIterator * memPoolIterate(void);
-extern MemPool * memPoolIterateNext(MemPoolIterator * iter);
-extern void memPoolIterateDone(MemPoolIterator ** iter);
+SQUIDCEXTERN MemPool *memPoolCreate(const char *label, size_t obj_size);
+SQUIDCEXTERN void *memPoolAlloc(MemPool * pool);
+SQUIDCEXTERN void memPoolFree(MemPool * pool, void *obj);
+SQUIDCEXTERN void memPoolDestroy(MemPool ** pool);
+
+SQUIDCEXTERN MemPoolIterator * memPoolIterate(void);
+SQUIDCEXTERN MemPool * memPoolIterateNext(MemPoolIterator * iter);
+SQUIDCEXTERN void memPoolIterateDone(MemPoolIterator ** iter);
 
 /* Tune API */
-extern void memPoolSetChunkSize(MemPool * pool, size_t chunksize);
-extern void memPoolSetIdleLimit(size_t new_idle_limit);
+SQUIDCEXTERN void memPoolSetChunkSize(MemPool * pool, size_t chunksize);
+SQUIDCEXTERN void memPoolSetIdleLimit(size_t new_idle_limit);
 
 /* Stats API */
-extern int memPoolGetStats(MemPoolStats * stats, MemPool * pool);
-extern int memPoolGetGlobalStats(MemPoolGlobalStats * stats);
+SQUIDCEXTERN int memPoolGetStats(MemPoolStats * stats, MemPool * pool);
+SQUIDCEXTERN int memPoolGetGlobalStats(MemPoolGlobalStats * stats);
 
 /* Module housekeeping API */
-extern void memPoolClean(time_t maxage);
+SQUIDCEXTERN void memPoolClean(time_t maxage);
 
 #if UNUSED
 /* Stats history API */
-extern void memPoolCheckRates(); /* stats history checkpoints */
+SQUIDCEXTERN void memPoolCheckRates(); /* stats history checkpoints */
 #endif
 
 #endif /* _MEM_POOLS_H_ */
Index: squid/include/Stack.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Stack.h,v
retrieving revision 1.5
retrieving revision 1.5.44.1
diff -u -r1.5 -r1.5.44.1
--- squid/include/Stack.h	9 Oct 2001 21:17:59 -0000	1.5
+++ squid/include/Stack.h	3 Oct 2002 01:04:32 -0000	1.5.44.1
@@ -1,5 +1,5 @@
 /*
- * $Id: Stack.h,v 1.5 2001/10/09 21:17:59 squidadm Exp $
+ * $Id: Stack.h,v 1.5.44.1 2002/10/03 01:04:32 rbcollins Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -42,9 +42,9 @@
 #define stackInit arrayInit
 #define stackClean arrayClean
 #define stackDestroy arrayDestroy
-extern void *stackPop(Stack * s);
+SQUIDCEXTERN void *stackPop(Stack * s);
 #define stackPush arrayAppend
 #define stackPrePush arrayPreAppend
-extern void *stackTop(Stack * s);
+SQUIDCEXTERN void *stackTop(Stack * s);
 
 #endif /* SQUID_STACK_H */
Index: squid/include/config.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/config.h,v
retrieving revision 1.5
retrieving revision 1.5.52.1
diff -u -r1.5 -r1.5.52.1
--- squid/include/config.h	13 Nov 2001 22:19:32 -0000	1.5
+++ squid/include/config.h	3 Oct 2002 01:04:32 -0000	1.5.52.1
@@ -37,6 +37,13 @@
 #include "autoconf.h"		/* For GNU autoconf variables */
 #include "version.h"
 
+/* To keep API definitions clear */
+#ifdef __cplusplus
+#define SQUIDCEXTERN extern "C"
+#else
+#define SQUIDCEXTERN extern
+#endif
+
 /****************************************************************************
  *--------------------------------------------------------------------------*
  * DO *NOT* MAKE ANY CHANGES below here unless you know what you're doing...*
@@ -120,26 +127,121 @@
  *  the return codes of programs in if statements.  These options
  *  need to be overridden.
  */
-#ifndef socklen_t
-#define socklen_t int
 #endif
-#ifndef fd_mask
-#define fd_mask unsigned long
+
+/* Typedefs for missing entries on a system */
+
+#include "squid_types.h"
+
+/* int16_t */
+#ifndef HAVE_INT16_T
+#if HAVE_SHORT && SIZEOF_SHORT == 2
+typedef short int16_t;
+#elif HAVE_INT && SIZEOF_INT == 2
+typedef int int16_t;
+#else
+#error NO 16 bit signed type available
+#endif
+#endif
+
+/* u_int16_t */
+#ifndef HAVE_U_INT16_T
+#if HAVE_UINT16_T
+typedef uint16_t u_int16_t;
+#else
+typedef unsigned int16_t u_int16_t;
+#endif
+#endif
+
+/* int32_t */
+#ifndef HAVE_INT32_T
+#if HAVE_INT && SIZEOF_INT == 4
+typedef int int32_t;
+#elif HAVE_LONG && SIZEOF_LONG == 4
+typedef long int32_t;
+#else
+#error NO 32 bit signed type available
+#endif
+#endif
+
+/* u_int32_t */
+#ifndef HAVE_U_INT32_T
+#if HAVE_UINT32_T
+typedef uint32_t u_int32_t;
+#else
+typedef unsigned int32_t u_int32_t;
+#endif
+#endif
+
+/* int64_t */
+#ifndef HAVE_INT64_T
+#if HAVE___INT64
+typedef __int64 int64_t;
+#elif HAVE_LONG && SIZEOF_LONG == 8
+typedef long int64_t;
+#elif HAVE_LONG_LONG && SIZEOF_LONG_LONG == 8
+typedef long long int64_t;
+#else
+#error NO 64 bit signed type available
+#endif
+#endif
+
+/* u_int64_t */
+#ifndef HAVE_U_INT64_T
+#if HAVE_UINT64_T
+typedef uint64_t u_int64_t;
+#else
+typedef unsigned int64_t u_int64_t;
+#endif
+#endif
+
+
+#ifndef HAVE_PID_T
+typedef int pid_t;
+#endif
+
+#ifndef HAVE_SIZE_T
+typedef unsigned int size_t;
 #endif
+
+#ifndef HAVE_SSIZE_T
+typedef int ssize_t;
+#endif
+
+#ifndef HAVE_OFF_T
+typedef int off_t;
+#endif
+
+#ifndef HAVE_MODE_T
+typedef unsigned short mode_t;
+#endif
+
+#ifndef HAVE_FD_MASK
+typedef unsigned long fd_mask;
+#endif
+
+#ifndef HAVE_SOCKLEN_T
+typedef int socklen_t;
+#endif
+
+#ifndef HAVE_MTYP_T
+typedef long mtyp_t;
 #endif
 
 #if !defined(CACHEMGR_HOSTNAME)
 #define CACHEMGR_HOSTNAME ""
 #endif
 
-#if SQUID_UDP_SO_SNDBUF > 16384
-#undef SQUID_UDP_SO_SNDBUF
+#if SQUID_DETECT_UDP_SO_SNDBUF > 16384
 #define SQUID_UDP_SO_SNDBUF 16384
+#else
+#define SQUID_UDP_SO_SNDBUF SQUID_DETECT_UDP_SO_SNDBUF
 #endif
 
-#if SQUID_UDP_SO_RCVBUF > 16384
-#undef SQUID_UDP_SO_RCVBUF
+#if SQUID_DETECT_UDP_SO_RCVBUF > 16384
 #define SQUID_UDP_SO_RCVBUF 16384
+#else
+#define SQUID_UDP_SO_RCVBUF SQUID_DETECT_UDP_SO_RCVBUF
 #endif
 
 #ifdef HAVE_MEMCPY
Index: squid/include/hash.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/hash.h,v
retrieving revision 1.4
retrieving revision 1.4.44.1
diff -u -r1.4 -r1.4.44.1
--- squid/include/hash.h	9 Oct 2001 21:17:59 -0000	1.4
+++ squid/include/hash.h	3 Oct 2002 01:04:32 -0000	1.4.44.1
@@ -1,5 +1,5 @@
 /*
- * $Id: hash.h,v 1.4 2001/10/09 21:17:59 squidadm Exp $
+ * $Id: hash.h,v 1.4.44.1 2002/10/03 01:04:32 rbcollins Exp $
  */
 
 #ifndef SQUID_HASH_H
@@ -26,18 +26,18 @@
     int count;
 };
 
-extern hash_table *hash_create(HASHCMP *, int, HASHHASH *);
-extern void hash_join(hash_table *, hash_link *);
-extern void hash_remove_link(hash_table *, hash_link *);
+SQUIDCEXTERN hash_table *hash_create(HASHCMP *, int, HASHHASH *);
+SQUIDCEXTERN void hash_join(hash_table *, hash_link *);
+SQUIDCEXTERN void hash_remove_link(hash_table *, hash_link *);
 extern int hashPrime(int n);
-extern void *hash_lookup(hash_table *, const void *);
-extern void hash_first(hash_table *);
-extern void *hash_next(hash_table *);
+SQUIDCEXTERN void *hash_lookup(hash_table *, const void *);
+SQUIDCEXTERN void hash_first(hash_table *);
+SQUIDCEXTERN void *hash_next(hash_table *);
 extern void hash_last(hash_table *);
 extern hash_link *hash_get_bucket(hash_table *, unsigned int);
 extern void hashFreeMemory(hash_table *);
-extern void hashFreeItems(hash_table *, HASHFREE *);
-extern HASHHASH hash_string;
+SQUIDCEXTERN void hashFreeItems(hash_table *, HASHFREE *);
+SQUIDCEXTERN HASHHASH hash_string;
 extern HASHHASH hash4;
 extern const char *hashKeyStr(hash_link *);
 
Index: squid/include/rfc2617.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/rfc2617.h,v
retrieving revision 1.4
retrieving revision 1.4.44.1
diff -u -r1.4 -r1.4.44.1
--- squid/include/rfc2617.h	9 Oct 2001 21:17:59 -0000	1.4
+++ squid/include/rfc2617.h	3 Oct 2002 01:04:32 -0000	1.4.44.1
@@ -56,7 +56,7 @@
 typedef char HASHHEX[HASHHEXLEN + 1];
 
 /* calculate H(A1) as per HTTP Digest spec */
-void DigestCalcHA1(
+SQUIDCEXTERN void DigestCalcHA1(
     const char *pszAlg,
     const char *pszUserName,
     const char *pszRealm,
@@ -68,7 +68,7 @@
 );
 
 /* calculate request-digest/response-digest as per HTTP Digest spec */
-void DigestCalcResponse(
+SQUIDCEXTERN void DigestCalcResponse(
     const HASHHEX HA1,		/* H(A1) */
     const char *pszNonce,	/* nonce from server */
     const char *pszNonceCount,	/* 8 hex digits */
@@ -80,8 +80,8 @@
     HASHHEX Response		/* request-digest or response-digest */
 );
 
-void CvtHex(const HASH Bin, HASHHEX Hex);
+SQUIDCEXTERN void CvtHex(const HASH Bin, HASHHEX Hex);
 
-void CvtBin(const HASHHEX Hex, HASH Bin);
+SQUIDCEXTERN void CvtBin(const HASHHEX Hex, HASH Bin);
 
 #endif /* SQUID_RFC2617_H */
Index: squid/include/util.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/util.h,v
retrieving revision 1.11
retrieving revision 1.11.20.1
diff -u -r1.11 -r1.11.20.1
--- squid/include/util.h	6 Apr 2002 11:34:49 -0000	1.11
+++ squid/include/util.h	3 Oct 2002 01:04:32 -0000	1.11.20.1
@@ -1,5 +1,5 @@
 /*
- * $Id: util.h,v 1.11 2002/04/06 11:34:49 squidadm Exp $
+ * $Id: util.h,v 1.11.20.1 2002/10/03 01:04:32 rbcollins Exp $
  *
  * AUTHOR: Harvest Derived
  *
@@ -62,34 +62,34 @@
 #endif
 
 extern const char *getfullhostname(void);
-extern const char *mkhttpdlogtime(const time_t *);
-extern const char *mkrfc1123(time_t);
-extern char *uudecode(const char *);
-extern char *xstrdup(const char *);
-extern char *xstrndup(const char *, size_t);
-extern const char *xstrerror(void);
+SQUIDCEXTERN const char *mkhttpdlogtime(const time_t *);
+SQUIDCEXTERN const char *mkrfc1123(time_t);
+SQUIDCEXTERN char *uudecode(const char *);
+SQUIDCEXTERN char *xstrdup(const char *);
+SQUIDCEXTERN char *xstrndup(const char *, size_t);
+SQUIDCEXTERN const char *xstrerror(void);
 extern const char *xbstrerror(int);
 extern int tvSubMsec(struct timeval, struct timeval);
 extern int tvSubUsec(struct timeval, struct timeval);
 extern double tvSubDsec(struct timeval, struct timeval);
-extern char *xstrncpy(char *, const char *, size_t);
+SQUIDCEXTERN char *xstrncpy(char *, const char *, size_t);
 extern size_t xcountws(const char *str);
 extern time_t parse_rfc1123(const char *str);
-extern void *xcalloc(size_t, size_t);
-extern void *xmalloc(size_t);
-extern void *xrealloc(void *, size_t);
-extern void Tolower(char *);
-extern void xfree(void *);
-extern void xxfree(const void *);
+SQUIDCEXTERN void *xcalloc(size_t, size_t);
+SQUIDCEXTERN void *xmalloc(size_t);
+SQUIDCEXTERN void *xrealloc(void *, size_t);
+SQUIDCEXTERN void Tolower(char *);
+SQUIDCEXTERN void xfree(void *);
+SQUIDCEXTERN void xxfree(const void *);
 
 /* rfc1738.c */
-extern char *rfc1738_escape(const char *);
+SQUIDCEXTERN char *rfc1738_escape(const char *);
 extern char *rfc1738_escape_unescaped(const char *);
-extern char *rfc1738_escape_part(const char *);
-extern void rfc1738_unescape(char *);
+SQUIDCEXTERN char *rfc1738_escape_part(const char *);
+SQUIDCEXTERN void rfc1738_unescape(char *);
 
 /* html.c */
-extern char *html_quote(const char *);
+SQUIDCEXTERN char *html_quote(const char *);
 
 #if XMALLOC_STATISTICS
 extern void malloc_statistics(void (*)(int, int, int, void *), void *);
@@ -111,11 +111,11 @@
 #endif
 
 typedef struct in_addr SIA;
-extern int safe_inet_addr(const char *, SIA *);
+SQUIDCEXTERN int safe_inet_addr(const char *, SIA *);
 extern time_t parse_iso3307_time(const char *buf);
 extern char *base64_decode(const char *coded);
-extern const char *base64_encode(const char *decoded);
-extern const char *base64_encode_bin(const char *data, int len);
+SQUIDCEXTERN const char *base64_encode(const char *decoded);
+SQUIDCEXTERN const char *base64_encode_bin(const char *data, int len);
 
 extern double xpercent(double part, double whole);
 extern int xpercentInt(double part, double whole);
Index: squid/lib/Array.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/Array.c,v
retrieving revision 1.5
retrieving revision 1.5.92.1
diff -u -r1.5 -r1.5.92.1
--- squid/lib/Array.c	7 Feb 2001 19:11:47 -0000	1.5
+++ squid/lib/Array.c	3 Oct 2002 01:04:32 -0000	1.5.92.1
@@ -1,5 +1,5 @@
 /*
- * $Id: Array.c,v 1.5 2001/02/07 19:11:47 hno Exp $
+ * $Id: Array.c,v 1.5.92.1 2002/10/03 01:04:32 rbcollins Exp $
  *
  * AUTHOR: Alex Rousskov
  *
@@ -119,7 +119,7 @@
     /* actual grow */
     assert(delta > 0);
     a->capacity += delta;
-    a->items = a->items ?
+    a->items = a->items ? 
 	xrealloc(a->items, a->capacity * sizeof(void *)) :
          xmalloc(a->capacity * sizeof(void *));
     /* reset, just in case */
--- /dev/null	Wed Feb 14 01:05:20 2007
+++ squid/src/HttpRequest.cc	Wed Feb 14 01:07:15 2007
@@ -0,0 +1,161 @@
+
+/*
+ * $Id: HttpRequest.cc,v 1.1.2.1 2002/10/03 01:04:33 rbcollins Exp $
+ *
+ * DEBUG: section 73    HTTP Request
+ * AUTHOR: Duane Wessels
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+#include "authenticate.h"
+
+request_t *
+requestCreate(method_t method, protocol_t protocol, const char *urlpath)
+{
+    request_t *req = static_cast<request_t *>(memAllocate(MEM_REQUEST_T));
+    req->method = method;
+    req->protocol = protocol;
+    if (urlpath)
+	stringReset(&req->urlpath, urlpath);
+    req->max_forwards = -1;
+    req->lastmod = -1;
+    req->client_addr = no_addr;
+    req->my_addr = no_addr;
+    httpHeaderInit(&req->header, hoRequest);
+    return req;
+}
+
+void
+requestDestroy(request_t * req)
+{
+    assert(req);
+    if (req->body_connection)
+	clientAbortBody(req);
+    if (req->auth_user_request)
+	authenticateAuthUserRequestUnlock(req->auth_user_request);
+    safe_free(req->canonical);
+    safe_free(req->vary_headers);
+    stringClean(&req->urlpath);
+    httpHeaderClean(&req->header);
+    if (req->cache_control)
+	httpHdrCcDestroy(req->cache_control);
+    if (req->range)
+	httpHdrRangeDestroy(req->range);
+    memFree(req, MEM_REQUEST_T);
+}
+
+request_t *
+requestLink(request_t * request)
+{
+    assert(request);
+    request->link_count++;
+    return request;
+}
+
+void
+requestUnlink(request_t * request)
+{
+    if (!request)
+	return;
+    assert(request->link_count > 0);
+    if (--request->link_count > 0)
+	return;
+    requestDestroy(request);
+}
+
+int
+httpRequestParseHeader(request_t * req, const char *parse_start)
+{
+    const char *blk_start, *blk_end;
+    if (!httpMsgIsolateHeaders(&parse_start, &blk_start, &blk_end))
+	return 0;
+    return httpHeaderParse(&req->header, blk_start, blk_end);
+}
+
+/* swaps out request using httpRequestPack */
+void
+httpRequestSwapOut(const request_t * req, StoreEntry * e)
+{
+    Packer p;
+    assert(req && e);
+    packerToStoreInit(&p, e);
+    httpRequestPack(req, &p);
+    packerClean(&p);
+}
+
+/* packs request-line and headers, appends <crlf> terminator */
+void
+httpRequestPack(const request_t * req, Packer * p)
+{
+    assert(req && p);
+    /* pack request-line */
+    packerPrintf(p, "%s %s HTTP/1.0\r\n",
+	RequestMethodStr[req->method], strBuf(req->urlpath));
+    /* headers */
+    httpHeaderPackInto(&req->header, p);
+    /* trailer */
+    packerAppend(p, "\r\n", 2);
+}
+
+#if UNUSED_CODE
+void
+httpRequestSetHeaders(request_t * req, method_t method, const char *uri, const char *header_str)
+{
+    assert(req && uri && header_str);
+    assert(!req->header.len);
+    httpHeaderParse(&req->header, header_str, header_str + strlen(header_str));
+}
+
+#endif
+
+/* returns the length of request line + headers + crlf */
+int
+httpRequestPrefixLen(const request_t * req)
+{
+    assert(req);
+    return strlen(RequestMethodStr[req->method]) + 1 +
+	strLen(req->urlpath) + 1 +
+	4 + 1 + 3 + 2 +
+	req->header.len + 2;
+}
+
+/*
+ * Returns true if HTTP allows us to pass this header on.  Does not
+ * check anonymizer (aka header_access) configuration.
+ */
+int
+httpRequestHdrAllowed(const HttpHeaderEntry * e, String * strConn)
+{
+    assert(e);
+    /* check connection header */
+    if (strConn && strListIsMember(strConn, strBuf(e->name), ','))
+	return 0;
+    return 1;
+}
--- /dev/null	Wed Feb 14 01:05:20 2007
+++ squid/src/IPInterception.cc	Wed Feb 14 01:07:15 2007
@@ -0,0 +1,194 @@
+
+/*
+ * $Id: IPInterception.cc,v 1.1.2.1 2002/10/03 01:04:33 rbcollins Exp $
+ *
+ * DEBUG: section 89    NAT / IP Interception 
+ * AUTHOR: Robert Collins
+ *
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
+ * ----------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+
+#include "squid.h"
+#include "clientStream.h"
+#include "IPInterception.h"
+
+#if IPF_TRANSPARENT
+#if HAVE_SYS_IOCTL_H
+#include <sys/ioctl.h>
+#endif
+#include <netinet/tcp.h>
+#include <net/if.h>
+#if HAVE_IP_FIL_COMPAT_H
+#include <ip_fil_compat.h>
+#elif HAVE_NETINET_IP_FIL_COMPAT_H
+#include <netinet/ip_fil_compat.h>
+#elif HAVE_IP_COMPAT_H
+#include <ip_compat.h>
+#elif HAVE_NETINET_IP_COMPAT_H
+#include <netinet/ip_compat.h>
+#endif
+#if HAVE_IP_FIL_H
+#include <ip_fil.h>
+#elif HAVE_NETINET_IP_FIL_H
+#include <netinet/ip_fil.h>
+#endif
+#if HAVE_IP_NAT_H
+#include <ip_nat.h>
+#elif HAVE_NETINET_IP_NAT_H
+#include <netinet/ip_nat.h>
+#endif
+#endif
+
+#if PF_TRANSPARENT
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/ioctl.h>
+#include <sys/fcntl.h>
+#include <net/if.h>
+#include <netinet/in.h>
+#include <net/pfvar.h>
+#endif
+
+#if LINUX_NETFILTER
+#include <linux/netfilter_ipv4.h>
+#endif
+
+void
+rewriteURIwithInterceptedDetails(char const *originalURL, char *uriBuffer, size_t bufferLength, int fd, struct sockaddr_in me, struct sockaddr_in peer, int vport)
+{
+#if IPF_TRANSPARENT
+    struct natlookup natLookup;
+    static int natfd = -1;
+    static int siocgnatl_cmd = SIOCGNATL & 0xff;
+    int x;
+#endif
+#if PF_TRANSPARENT
+    struct pfioc_natlook nl;
+    static int pffd = -1;
+#endif
+#if LINUX_NETFILTER
+    size_t sock_sz = sizeof(me);
+#endif
+#if IPF_TRANSPARENT
+    natLookup.nl_inport = me.sin_port;
+    natLookup.nl_outport = peer.sin_port;
+    natLookup.nl_inip = me.sin_addr;
+    natLookup.nl_outip = peer.sin_addr;
+    natLookup.nl_flags = IPN_TCP;
+    if (natfd < 0) {
+	int save_errno;
+	enter_suid();
+	natfd = open(IPL_NAT, O_RDONLY, 0);
+	save_errno = errno;
+	leave_suid();
+	errno = save_errno;
+    }
+    if (natfd < 0) {
+	debug(89, 1) ("rewriteURIwithInterceptedDetails: NAT open failed: %s\n",
+	    xstrerror());
+	cbdataFree(context);
+	xfree(inbuf);
+	return rewriteURIwithInterceptedDetailsAbort(conn, "error:nat-open-failed");
+    }
+    /* 
+     * IP-Filter changed the type for SIOCGNATL between
+     * 3.3 and 3.4.  It also changed the cmd value for
+     * SIOCGNATL, so at least we can detect it.  We could
+     * put something in configure and use ifdefs here, but
+     * this seems simpler.
+     */
+    if (63 == siocgnatl_cmd) {
+	struct natlookup *nlp = &natLookup;
+	x = ioctl(natfd, SIOCGNATL, &nlp);
+    } else {
+	x = ioctl(natfd, SIOCGNATL, &natLookup);
+    }
+    if (x < 0) {
+	if (errno != ESRCH) {
+	    debug(89, 1) ("rewriteURIwithInterceptedDetails: NAT lookup failed: ioctl(SIOCGNATL)\n");
+	    close(natfd);
+	    natfd = -1;
+	    cbdataFree(context);
+	    xfree(inbuf);
+	    return rewriteURIwithInterceptedDetailsAbort(conn,
+		"error:nat-lookup-failed");
+	} else
+	    snprintf(uriBuffer, bufferLength, "http://%s:%d%s",
+		inet_ntoa(me.sin_addr), vport, originalURL);
+    } else {
+	if (vport_mode)
+	    vport = ntohs(natLookup.nl_realport);
+	snprintf(uriBuffer, bufferLength, "http://%s:%d%s",
+	    inet_ntoa(natLookup.nl_realip), vport, originalURL);
+    }
+#elif PF_TRANSPARENT
+    if (pffd < 0)
+	pffd = open("/dev/pf", O_RDWR);
+    if (pffd < 0) {
+	debug(89, 1) ("rewriteURIwithInterceptedDetails: PF open failed: %s\n",
+	    xstrerror());
+	cbdataFree(context);
+	xfree(inbuf);
+	return rewriteURIwithInterceptedDetailsAbort(conn, "error:pf-open-failed");
+    }
+    memset(&nl, 0, sizeof(struct pfioc_natlook));
+    nl.saddr.v4.s_addr = peer.sin_addr.s_addr;
+    nl.sport = peer.sin_port;
+    nl.daddr.v4.s_addr = me.sin_addr.s_addr;
+    nl.dport = me.sin_port;
+    nl.af = AF_INET;
+    nl.proto = IPPROTO_TCP;
+    nl.direction = PF_OUT;
+    if (ioctl(pffd, DIOCNATLOOK, &nl)) {
+	if (errno != ENOENT) {
+	    debug(89, 1) ("rewriteURIwithInterceptedDetails: PF lookup failed: ioctl(DIOCNATLOOK)\n");
+	    close(pffd);
+	    pffd = -1;
+	    cbdataFree(context);
+	    xfree(inbuf);
+	    return rewriteURIwithInterceptedDetailsAbort(conn,
+		"error:pf-lookup-failed");
+	} else
+	    snprintf(uriBuffer, bufferLength, "http://%s:%d%s",
+		inet_ntoa(me.sin_addr), vport, originalURL);
+    } else
+	snprintf(uriBuffer, bufferLength, "http://%s:%d%s",
+	    inet_ntoa(nl.rdaddr.v4), ntohs(nl.rdport), originalURL);
+#else
+#if LINUX_NETFILTER
+    /* If the call fails the address structure will be unchanged */
+    getsockopt(fd, SOL_IP, SO_ORIGINAL_DST, &me, &sock_sz);
+    debug(89, 5) ("rewriteURIwithInterceptedDetails: addr = %s",
+	inet_ntoa(me.sin_addr));
+    if (vport_mode)
+	vport = (int) ntohs(me.sin_port);
+#endif
+    snprintf(uriBuffer, bufferLength, "http://%s:%d%s",
+	inet_ntoa(me.sin_addr), vport, originalURL);
+#endif
+}
Index: squid/src/IPInterception.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/IPInterception.h,v
retrieving revision 1.3
retrieving revision 1.3.6.1
diff -u -r1.3 -r1.3.6.1
--- squid/src/IPInterception.h	27 Sep 2002 21:45:34 -0000	1.3
+++ squid/src/IPInterception.h	3 Oct 2002 01:04:33 -0000	1.3.6.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: IPInterception.h,v 1.3 2002/09/27 21:45:34 squidadm Exp $
+ * $Id: IPInterception.h,v 1.3.6.1 2002/10/03 01:04:33 rbcollins Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -34,7 +34,7 @@
 #ifndef SQUID_IPINTERCEPTION_H
 #define SQUID_IPINTERCEPTION_H
 
-void
+SQUIDCEXTERN void
      rewriteURIwithInterceptedDetails(char const *originalURL, char *uriBuffer, size_t bufferLength, int fd, struct sockaddr_in me, struct sockaddr_in peer, int vport);
 
 #endif /* SQUID_IPINTERCEPTION_H */
Index: squid/src/Makefile.am
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Makefile.am,v
retrieving revision 1.29
retrieving revision 1.29.2.1
diff -u -r1.29 -r1.29.2.1
--- squid/src/Makefile.am	2 Oct 2002 11:10:44 -0000	1.29
+++ squid/src/Makefile.am	3 Oct 2002 01:04:33 -0000	1.29.2.1
@@ -115,11 +115,11 @@
 	win32.c
 
 squid_SOURCES = \
-	access_log.c \
+	access_log.cc \
 	acl.c \
 	asn.c \
-	authenticate.c \
-	cache_cf.c \
+	authenticate.cc \
+	cache_cf.cc \
 	CacheDigest.c \
 	cache_manager.c \
 	carp.c \
@@ -141,7 +141,7 @@
 	disk.c \
 	$(DNSSOURCE) \
 	enums.h \
-	errorpage.c \
+	errorpage.cc \
 	ETag.c \
 	event.c \
 	external_acl.c \
@@ -154,7 +154,7 @@
 	gopher.c \
 	helper.c \
 	$(HTCPSOURCE) \
-	http.c \
+	http.cc \
 	HttpStatusLine.c \
 	HttpHdrCc.c \
 	HttpHdrRange.c \
@@ -164,7 +164,7 @@
 	HttpBody.c \
 	HttpMsg.c \
 	HttpReply.c \
-	HttpRequest.c \
+	HttpRequest.cc \
 	icmp.c \
 	icp_v2.c \
 	icp_v3.c \
@@ -172,11 +172,11 @@
 	internal.c \
 	ipc.c \
 	ipcache.c \
-	IPInterception.c \
+	IPInterception.cc \
 	IPInterception.h \
 	$(LEAKFINDERSOURCE) \
-	logfile.c \
-	main.c \
+	logfile.cc \
+	main.cc \
 	mem.c \
 	MemBuf.c \
 	mime.c \
@@ -189,7 +189,7 @@
 	peer_digest.c \
 	peer_select.c \
 	protos.h \
-	redirect.c \
+	redirect.cc \
 	referer.c \
 	refresh.c \
 	send-announce.c \
@@ -228,7 +228,7 @@
 
 nodist_squid_SOURCES = \
 	repl_modules.c \
-	auth_modules.c \
+	auth_modules.cc \
 	store_modules.c \
 	cf_parser.h \
 	globals.c \
@@ -267,7 +267,7 @@
 	globals.c \
 	string_arrays.c \
 	repl_modules.c \
-	auth_modules.c \
+	auth_modules.cc \
 	store_modules.c
 
 sysconf_DATA = \
@@ -366,8 +366,8 @@
 repl_modules.c: repl_modules.sh Makefile
 	$(SHELL) $(srcdir)/repl_modules.sh $(REPL_POLICIES) > repl_modules.c
 
-auth_modules.c: auth_modules.sh Makefile
-	@$(SHELL) $(srcdir)/auth_modules.sh $(AUTH_MODULES) >auth_modules.c
+auth_modules.cc: auth_modules.sh Makefile
+	@$(SHELL) $(srcdir)/auth_modules.sh $(AUTH_MODULES) >auth_modules.cc
 
 install-data-local: install-sysconfDATA install-dataDATA
 	@if test -f $(DESTDIR)$(DEFAULT_MIME_TABLE) ; then \
@@ -395,7 +395,7 @@
 	fi
 
 DISTCLEANFILES = cf_gen_defines.h cf.data cf_parser.h squid.conf.default \
-	globals.c string_arrays.c repl_modules.c auth_modules.c store_modules.c
+	globals.c string_arrays.c repl_modules.c auth_modules.cc store_modules.c
 
 ##install-pinger:
 ##	@f=$(PINGER_EXE); \
